<?php
// $Id$

/**
 * @file
 * OM Maximenu Admin Configuration
 *
 * @author: Daniel Honrade http://drupal.org/user/351112
 *
 */
 
/**
 * Admin Form - Simple Editing
 *
 */
function om_maximenu_admin() {
  drupal_set_title(t('OM Maximenu Settings'));
  
  $menus = array();
  $maximenus = variable_get('om_maximenu', $menus);
  ksort($maximenus);
  //dsm($maximenus);
  $form = array();
  $form['om_maximenus'] = array(
    '#type' => 'fieldset',
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => TRUE,
    '#description' => t('These OM Maximenu blocks are automatically added to <a href="' . base_path() . 'admin/build/block/list">Block List</a> where you can place them in any region.'),
  );
  
  $result = db_query("SELECT rid, name FROM {role} ORDER BY rid ASC");
  
  while ($record = db_fetch_object($result)) {
    $roles[$record->rid] = $record->name;
  }
  
  $maximenus_array = array();
  if (!empty($maximenus)) {
    foreach ($maximenus as $menu_key => $menu_content) {
      $maximenus_array[$menu_key] = array(
        '#type'        => 'fieldset',
        '#title'       => $menu_content['title'],
        '#collapsible' => TRUE,
        '#collapsed'   => TRUE,
      );  
      //dsm($menu_content);
      $menu_content['menu_key'] = $menu_key;
      $menu_content['roles'] = $roles;    
      $maximenus_array[$menu_key] += _om_maximenu_admin($menu_content);
    }
  }
  
  // new ids relies on highest menukey id
  $count = !empty($maximenus) ? max(array_keys($maximenus)) + 1: 1;
  
  $menu_content_new['title'] = 'New Menu';
  $menu_content_new['links'] = array();
  $menu_content_new['menu_key'] = $count;
  $menu_content_new['roles'] = $roles;        
  $maximenus_array[$count] = array(
    '#type'        => 'fieldset',
    '#title'       => 'New Menu',
    '#collapsible' => TRUE,
    '#collapsed'   => TRUE,
  );  
  $maximenus_array[$count] += _om_maximenu_admin($menu_content_new);
  
  $form['om_maximenus'] += $maximenus_array; 
  

  $form['save'] = array( '#type' => 'submit', '#value' => t('Save'), );
  
  return $form;
}


/**
 * Admin Form
 *
 */
function _om_maximenu_admin($menu_content = array()) {
  static $first_menu = 0;
  $out   = array();
  $skin  = om_maximenu_style_get();
  $roles = $menu_content['roles'];
  //dsm($skin);
  if (trim($menu_content['title']) != 'New Menu') {
    $out['delete'] = array(
      '#type'  => 'checkbox',
      '#title' => t('Delete this menu.'),    
      '#default_value' => 0,
    );
  }
  $out['title'] = array(
    '#type'  => 'textfield',
    '#title' => t('Menu Block Title'),  
    '#required' => TRUE,  
    '#default_value' => trim($menu_content['title']),
  );
  $out['skin'] = array(
    '#type'  => 'select',
    '#title' => t('Skin'),
    '#options' => $skin,    
    '#default_value' => $menu_content['skin'],
  ); 
  $out['fade'] = array(
    '#type'  => 'checkbox',
    '#title' => t('Fade Effect'),
    '#default_value' => $menu_content['fade'],
  ); 
  if ($first_menu == 0) {  
    $out['main_menu'] = array(
      '#type'  => 'checkbox',
      '#title' => t('Use as main menu'),
      '#default_value' => $menu_content['main_menu'],
      '#description' => t('You have the option to make this as your main menu. This will automatically replace existing main menu for OM Base Theme. For other themes, add this &lt;?php print $main_menu_tree; ?&gt; to your page.tpl.php'),
    );     
  }
  $first_menu++;
  
  $links = array();

  if (!isset($menu_content['links'])) $menu_content['links'] = array();
  
  // new link ids will depend on the highest existing link id;
  $count = !empty($menu_content['links']) ? max(array_keys($menu_content['links'])) + 1: 1;
  
  $menu_content['links'] += _om_new_link($count, $roles);
 
  //dsm($menu_content['links']);
  foreach ($menu_content['links'] as $link => $prop) {
    $enabled_blocks = isset($prop['content']) ? count($prop['content']): 0;  

    $links['links'][$link] = array(
      '#type'   => 'fieldset',
      '#title'  => $prop['link_title'],
      '#collapsible' => TRUE,
      '#collapsed'   => TRUE,
      '#description' => (!empty($prop['link_title']) && ($prop['link_title'] != 'New Link')) ? t('@enabled_blocks enabled blocks, <strong><a href="@link">Click here </a></strong> to Enable/Disable blocks on this link.', array('@enabled_blocks' => $enabled_blocks, '@link' => base_path() . 'admin/settings/om-maximenu/blocks/' . $menu_content['menu_key'] . '/' . $link . '?destination=admin/settings/om-maximenu')): t('<strong>You can only enable/disable blocks on this link if you have modified the link title.</strong>'),         
    );
    if (trim($prop['link_title']) != 'New Link') {
      $links['links'][$link]['link_delete'] = array(
        '#type'   => 'checkbox',
        '#title'  => 'Delete this link.',
        '#default_value'  => 0,      
      );    
    }
    $links['links'][$link]['link_title'] = array(
      '#type'   => 'textfield',
      '#title'  => 'Link Title',
      '#required' => TRUE,        
      '#default_value'  => trim($prop['link_title']),      
    );
    $links['links'][$link]['path'] = array(
      '#type'   => 'textfield',
      '#title'  => 'Path',
      '#default_value'  => trim($prop['path']),
      '#description' => t('
        <ul>
          <li><strong>Front Page</strong> - put &lt;front&gt; as path.</li>
          <li><strong>No Link</strong> - empty path is valid and will transform "a" tag to "span" tag.</li>
          <li><strong>Anchor</strong> - accepts "#" as valid path, which can correspond to id properties of a tag, ex. &lt;div id="section-1",<br /> 
          so you can now target this section by doing "about#section-1", and the page will automatically scroll to that section.</li>
        </ul>  
          '),      
    );  
    $links['links'][$link]['link_title_option'] = array(
      '#type'   => 'select',
      '#title'  => 'Options for Link Title',
      '#default_value'  => $prop['link_title_option'],
      '#options' => array('title' => 'Title only', 'title_icon' => 'Title with Icon', 'icon' => 'Icon only'),
    );        
    $links['links'][$link]['path_icon'] = array(
      '#type'   => 'textfield',
      '#title'  => 'Icon Path',
      '#default_value'  => trim($prop['path_icon']),
      '#description' => t('
        Ex. sites/default/themes/mytheme/css/images/icon_1.png or<br />
        sites/default/files/icon_1.png <br />        
        (By default, this icon will go to the left side of the link title.). <br />
        This can also be done via css properties, ex .link-home { background: url(...)...'),      
    );              
    $links['links'][$link]['id'] = array(
      '#type'   => 'textfield',
      '#title'  => 'ID',
      '#default_value'  => trim($prop['id']),
      '#description' => t('Make sure this ID is unique.'),      
    );
    $links['links'][$link]['class'] = array(
      '#type'   => 'textfield',
      '#title'  => 'Classes',
      '#default_value'  => trim($prop['class']),
    );
    $links['links'][$link]['rel'] = array(
      '#type'   => 'textfield',
      '#title'  => 'Relationship',
      '#default_value'  => $prop['rel'],
      '#description' => t('
        <ul>
          <li><strong>nofollow</strong> - for search engines not to follow the link.</li>
          <li><strong>lightbox</strong> - If you installed Lighbox 2, See your other options on Lightbox 2 README.txt.</a>.</li>
          <li>Other modules may have uses for this, so I just kept it as textfield.</li>
        </ul> 
      '),            
    );  
    $links['links'][$link]['target'] = array(
      '#type'   => 'select',
      '#title'  => 'Target Window',
      '#options' => array(
        '_self'   => 'Self', 
        '_blank'  => 'Blank',
        '_parent' => 'Parent',         
        '_top'    => 'Top',                                          
      ),
      '#default_value'  => $prop['target'],
    );       
    $links['links'][$link]['description'] = array(
      '#type'   => 'textfield',
      '#title'  => 'Description',
      '#default_value'  => $prop['description'],
      '#description' => t('This will appear on mouse hover state.'),
    );
    $links['links'][$link]['roles'] = array(
      '#type'    => 'checkboxes',
      '#title'   => 'User Roles',
      '#options' => $roles,
      '#default_value'  => $prop['roles'],
      '#description' => t('If none is checked, this link will appear for all.'),      
    );    
    //dsm($prop['content']);
    if (is_array($prop['content'])) {
      foreach ($prop['content'] as $block => $block_prop) {
        foreach ($block_prop as $block_key => $block_val) {    
          $links['links'][$link]['content'][$block][$block_key] = array(
            '#type'   => 'hidden',
            '#default_value'  => trim($block_val),
          );
        }
      }
    }

    $links['links'][$link]['weight'] = array(
      '#type'   => 'weight',
      '#title'  => 'Weight',
      '#delta' => 20,        
      '#default_value'  => $prop['weight'],
    );
  }
  
  $out += $links;

  return $out;
}


/**
 * OM Default New Links
 *
 */
function _om_new_link($count = 0, $roles = array()) {
  $out = array();
  $num = $count + 5;
  for ($i = $count; $i < $num; $i++) {
    $out[$i] = array(
      'link_title' => 'New Link',
      'path' => '',      
      'link_title_option' => 'title',  
      'path_icon' => '',                
      'id' => '',
      'class' => '',
      'rel' => '',
      'target' => '_self',            
      'description' => '',
      'roles' => $roles,      
      'weight' => 0,  
    );
  }
  return $out;
}

/**
 * 1 Submit for all settings
 *
 */
function om_maximenu_admin_submit($form, $form_state) {
  $om_maximenu_array = $form_state['values']['om_maximenus'];
  //dsm($om_maximenu_array); 
  $om_maximenu = array();
  foreach ($om_maximenu_array as $menu_id => $maximenu_block_content) {
    if (!empty($maximenu_block_content['title']) && ($maximenu_block_content['title'] != 'New Menu') && ($maximenu_block_content['delete'] != 1)) {
      $om_maximenu[$menu_id]['title']     = $maximenu_block_content['title'];
      $om_maximenu[$menu_id]['skin']      = $maximenu_block_content['skin'];
      $om_maximenu[$menu_id]['fade']      = $maximenu_block_content['fade']; 
      if ($maximenu_block_content['main_menu']) $om_maximenu[$menu_id]['main_menu'] = $maximenu_block_content['main_menu'];                 
      foreach ($maximenu_block_content['links'] as $link => $link_prop) {
        if (!empty($link_prop['link_title']) && ($link_prop['link_title'] != 'New Link') && ($link_prop['link_delete'] != 1)) {
          $om_maximenu[$menu_id]['links'][$link] = array(
            'link_title'        => $link_prop['link_title'],
            'path'              => $link_prop['path'],            
            'link_title_option' => $link_prop['link_title_option'],
            'path_icon'         => $link_prop['path_icon'],
            'id'                => $link_prop['id'],
            'class'             => $link_prop['class'],
            'rel'               => $link_prop['rel'],
            'target'            => $link_prop['target'],                        
            'description'       => $link_prop['description'],
            'roles'             => $link_prop['roles'],            
            'content'           => $link_prop['content'],
            'weight'            => $link_prop['weight'],
          );
        }
      }
    }
  }

  drupal_set_message(t('Your settings have been saved.'));
  
  // Save all settings in 1 variable
  variable_set('om_maximenu', $om_maximenu);
} 


/**
 * Adding Blocks
 *
 */
function om_maximenu_blocks_get() {
  drupal_set_title(t('OM Maximenu Blocks'));
  $args = arg();
  $menus = array();
  $maximenus = variable_get('om_maximenu', $menus);
  $menu_title = $maximenus[$args[4]]['title'];
  $link_title = $maximenus[$args[4]]['links'][$args[5]]['link_title'];
  $blocks_enabled = $maximenus[$args[4]]['links'][$args[5]]['content'];
  //dsm($blocks_enabled);

  $theme_default = variable_get('theme_default', 'garland');

  // default, module generated blocks
  $result = db_query("SELECT module, delta, title FROM {blocks} WHERE theme = '%s' ORDER BY module, delta ASC", $theme_default);
  
  while ($record = db_fetch_object($result)) {
    if ($record->module != 'om_maximenu') {
      $block  = module_invoke($record->module, 'block', 'view', $record->delta); 
      $title  = $record->title; 
      $module = $record->module;
      $delta  = $record->delta;    
      $modules[$module][$delta]['checked'] = isset($blocks_enabled[$module . '___' . $delta]) ? 1: 0; 
      //print $maxi_block_enabled[$module][$delta];  
      if (!empty($blocks_enabled[$module . '___' . $delta]['title'])) {       
        $modules[$module][$delta]['title'] =  $blocks_enabled[$module . '___' . $delta]['title'];       
      }
      else {
        $modules[$module][$delta]['title'] =  (empty($title) || ($title == '<none>')) ? (empty($block['subject'])) ? ucwords(preg_replace('/_/', ' ', $module)) . ' ' . $delta: $block['subject']: $title; 
      }
    }
  }
  //dsm($modules);
  $form = array();  
  $form['om_maximenu_content'] = array(
    '#type'        => 'fieldset',
    '#title'       => t($menu_title . ' / ' . $link_title),
    '#collapsible' => TRUE,
    '#collapsed'   => FALSE,
    '#tree'        => TRUE,
    '#description' => t('These are all the available blocks in your system. Choose the blocks which will appear under the navigation menu link.'),
  );
  
  foreach ($modules as $module => $blocks) {
    $total = count($modules[$module]);
    $count = 0;
    foreach ($blocks as $key => $checked) {
      if ($checked['checked']) $count++;
    } 
    $form['om_maximenu_content'][$module] = array(
      '#type'        => 'fieldset',
      '#title'       => t(ucwords(preg_replace('/_/', ' ', $module)) . ' (' . $count . ' of ' . $total . ')'),
      '#collapsible' => TRUE,
      '#collapsed'   => TRUE,
    );
    foreach ($blocks as $delta => $value) {
      $form['om_maximenu_content'][$module][$module . '___' . $delta] = array(
        '#type'          => 'fieldset',
        '#title'         => (trim($value['title'] != '<none>')) ? trim($value['title']): ucwords(t($module . ' ' . $delta)),
        '#collapsible' => TRUE,
        '#collapsed'   => FALSE,
      );     
      $form['om_maximenu_content'][$module][$module . '___' . $delta]['checked'] = array(
        '#type'          => 'checkbox',
        '#title'         => t('Enabled'), 
        '#default_value' => $value['checked'],   
      );     
      $form['om_maximenu_content'][$module][$module . '___' . $delta]['title'] = array(
        '#type'          => 'textfield',
        '#title'         => t('Title'), 
        '#default_value' => trim($value['title']),  
        '#description' => t('Put &lt;none&gt; for no title.'), 
      );
      $form['om_maximenu_content'][$module][$module . '___' . $delta]['title_path'] = array(
        '#type'          => 'textfield',
        '#title'         => t('Path'), 
        '#default_value' => trim($value['title_path']),  
        '#description' => t('You can make the title clickable by adding a path. Ex. &lt;front&gt;, somepath, node/1'), 
      );      
      $form['om_maximenu_content'][$module][$module . '___' . $delta]['module'] = array(
        '#type'          => 'hidden',
        '#default_value' => $module,   
      );        
      $form['om_maximenu_content'][$module][$module . '___' . $delta]['delta'] = array(
        '#type'          => 'hidden',
        '#default_value' => $delta,   
      ); 
      $form['om_maximenu_content'][$module][$module . '___' . $delta]['weight'] = array(
        '#type'          => 'weight',
        '#title'         => t('Weight'),
        '#delta'         => 20,
        '#default_value' => isset($value['weight']) ? $value['weight']: 0,   
      ); 
    }
  }   
   
  $form['save'] = array( '#type' => 'submit', '#value' => t('Save'), );
    
  return $form;
}  


/**
 * Adding Blocks Submit
 *
 */
function om_maximenu_blocks_get_submit($form, $form_state) {
  $args = arg();
  $maximenu_content = $form_state['values']['om_maximenu_content'];
  //dsm($maximenu_content);
  $content = array();
  foreach ($maximenu_content as $module => $blocks) {
    foreach ($blocks as $block => $value) {
      if ($value['checked']) {
        $content[$block] = array(
          'title'      => $value['title'],
          'title_path' => $value['title_path'],          
          'module'     => $value['module'], 
          'delta'      => $value['delta'],  
          'weight'     => $value['weight'],            
        );                     
      }
    }
  }
  //dsm($content);
  $menus = array();
  $om_maximenu = variable_get('om_maximenu', $menus);
  $om_maximenu[$args[4]]['links'][$args[5]]['content'] = $content;
  //dsm($om_maximenu);
  drupal_set_message(t('Your settings have been saved.'));
  
  // Save all settings in 1 variable
  variable_set('om_maximenu', $om_maximenu);
} 




